#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "fmp3.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int FMP3_check( void )
{
	char	id1[16];
	char	id2[16];

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));

	_readvect( 0xD2, 1, 0x010B, id1 );
	_readvect( 0xD2, 1, 0x0103, id2 );

	if( memcmp( id1, "FMP ", 4 ) != 0 )
	{
		if( memcmp( id2, "FMP ", 4 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		}
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int FMP3_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	return 0;
}

int FMP3_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	/* Music : BX:CX */
	r.x.ax = 0x0001;
	r.x.bx = seg;
	r.x.cx = off;

	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int FMP3_stop( void )
{
	r.x.ax = 0x0000;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int FMP3_fade( void )
{
	r.x.ax = 0x1209;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}
