#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <memory.h>

#include "fplay.h"
#include "..\common.h"
#include "..\extern.h"

int FPLAY_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x7F, 0, 4, id );

	if( memcmp( id, "SQR", 2 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int FPLAY_load( char *filename )
{
	long	filesize;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	/* Music : DS:DX */
	r.h.ah = 0x09;
	sr.ds  = FP_SEG( filename );
	r.x.dx = FP_OFF( filename );
	int86x( 0x7F, &r, &ro, &sr );

	printf( INFO[INFO_LOAD], filename, filesize );

	return 0;
}

int FPLAY_play( char *opt1, char *opt2 )
{
	if( strcmpi( opt1, OPT[OPT_SELECTOR] ) == 0 )
	{
		FPLAY_selector();
		return 0;
	}

	r.h.ah = 0x00;

	if( opt1 == NULL ) r.h.al = 0x00;
	else r.h.al = atoi( opt1 );

	int86x( 0x7F, &r, &ro, &sr );

	printf( INFO[INFO_NO], r.h.al );

	return 0;
}

int FPLAY_stop( void )
{
	r.h.ah = 0x03;
	int86x( 0x7F, &r, &ro, &sr );

	return 0;
}

int FPLAY_fade( void )
{
	r.h.ah = 0x04;
	r.h.al = 0x0C;
	int86x( 0x7F, &r, &ro, &sr );

	return 0;
}

int FPLAY_selector( void )
{
	int		no;
	char	buf[3];

	no = 0;

	for( ;; )
	{
		switch( getch())
		{
			case 0x0A:	/* DOWN */
				if( no > 0 ) no--;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0B:	/* UP */
				if( no < 255 ) no++;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0D:	/* ENTER */
				sprintf( buf, "%d", no );
				FPLAY_stop();
				FPLAY_play( buf, NULL );
				break;
			case 0x1B:	/* ESC */
				return 0;
			default: break;
		}
	}
}
