#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "miz3.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

unsigned char	MIZ3_type = 0;
char			*MIZ3_mtd = "*.MTD";

int MIZ3_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x40, 0, 0x7D, id );

	if( memcmp( id, "MIZ", 3 ) != 0 )
	{
		if( memcmp( id, "MMIZ", 4 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		} else MIZ3_type = 1;
	} else MIZ3_type = 0;

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MIZ3_load( char *filename )
{
	if( MIZ3_type == 1 )
	{
		struct find_t	ft;

		GMPV4SP_address( &seg, &off, 0 );

		if( _dos_findfirst( MIZ3_mtd, _A_NORMAL, &ft ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], MIZ3_mtd );
			return 1;
		}

		if( GMPV4SP_load( ft.name, 0, 0, 1 ) == -1 ) return 1;

		r.h.ah = 0x02;
		r.x.dx = seg;
		int86x( 0x40, &r, &ro, &sr );
	}

	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	return 0;
}

int MIZ3_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	r.x.ax = 0x0000;
	int86x( 0x40, &r, &ro, &sr );

	r.x.ax = 0x0100;
	r.x.dx = seg;
	int86x( 0x40, &r, &ro, &sr );

	/* Music : DS:DX */
	r.x.ax = 0x0501;
	int86x( 0x40, &r, &ro, &sr );

	return 0;
}

int MIZ3_stop( void )
{
	r.x.ax = 0x0700;
	int86x( 0x40, &r, &ro, &sr );

	r.x.ax = 0x0600;
	int86x( 0x40, &r, &ro, &sr );

	r.x.ax = 0x0600;
	int86x( 0x40, &r, &ro, &sr );

	return 0;
}
