#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <memory.h>

#include "music48.h"
#include "..\common.h"
#include "..\extern.h"

int MUSIC48_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x48, 1, -8, id );

	if( memcmp( id, "MUSIC", 5 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSIC48_load( char *filename )
{
	long	filesize;

	if( strcmpi( filename, OPT[OPT_SE] ) == 0 )
	{
		printf( INFO[INFO_LOAD], STR[STR_SE], 0L );
		return 0;
	}

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	/* Music : CX:DX */
	r.h.ah = 0x07;
	r.x.cx = FP_SEG( filename );
	r.x.dx = FP_OFF( filename );
	int86x( 0x48, &r, &ro, &sr );

	printf( INFO[INFO_LOAD], filename, filesize );

	return 0;
}

int MUSIC48_play( char *opt1, char *opt2 )
{
	if( opt1 != NULL )
	{
		/* se */
		r.h.ah = 0;
		r.h.dh = 0;
		r.h.dl = atoi( opt1 );
	} else {
		/* music */
		r.h.ah = 0x02;
	}
	int86x( 0x48, &r, &ro, &sr );

	return 0;
}

int MUSIC48_stop( void )
{
	r.h.ah = 0x03;
	int86x( 0x48, &r, &ro, &sr );

	return 0;
}
