#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <memory.h>
#include <farstr.h>

#include "musicd2.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int MUSICD2_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0xD2, 1, -8, id );

	if( memcmp( id, "MUSDRV", 6 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSICD2_load( char *filename )
{
	unsigned char far	*p = NULL;

	if( strcmpi( filename, OPT[OPT_SE] ) == 0 )
	{
		printf( INFO[INFO_LOAD], STR[STR_SE], 0L );
		return 0;
	}

	r.h.ah = 0x00;
	int86x( 0xD2, &r, &ro, &sr );
	p = MK_FP( sr.es, ro.x.bx );

	/* Music : ES:BX */
	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int MUSICD2_play( char *opt1, char *opt2 )
{
	if( opt1 != NULL )
	{
		/* se */
		r.h.ah = 0x05;
		r.h.al = atoi( opt1 );
	} else {
		/* music */
		r.h.ah = 0x01;
	}

	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int MUSICD2_stop( void )
{
	r.h.ah = 0x03;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}
