#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <farstr.h>
#include <dos.h>

#include "neodrv.h"
#include "..\common.h"
#include "..\extern.h"

char	*NEODRV_tone = "TONE.MTX";

int NEODRV_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x14, 0, -8, id );

	if( memcmp( id, "NEODRV", 6 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int NEODRV_load( char *filename )
{
	unsigned char far	*p = NULL;
	unsigned char far	*tone = NULL;
	long				filesize;

	if( strcmpi( filename, OPT[OPT_SE] ) == 0 )
	{
		printf( INFO[INFO_LOAD], STR[STR_SE], 0L );
		return 0;
	}

	/* Music : seg:[off - 0x12] */
	vect = _dos_getvect( 0x14 );
	p = ( unsigned char far *)vect;
	seg = FP_SEG( p );
	off = WORD2INT( p - 0x12 );
	p = MK_FP( seg, off );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	filesize = _filesize( NEODRV_tone );
	if( filesize == -1 ) return 1;
	tone = _far_calloc( filesize );
	if( tone == NULL ) return 1;
	_far_fileload( NEODRV_tone, tone );

	/* Tone : [Music - 0x0C00...] */
	{
		unsigned int	no;
		unsigned int	count = 0;
		unsigned short	no_offset = WORD2INT( p + 0x14 );

		for( ;; )
		{
			no = p[no_offset + count];
			if( no == 0xFF ) break;
			far_memcpy(
				( p - 0x0C00 ) + ( count * 0x20 ),
				&tone[no * 0x20],
				0x20
			);
			count++;
		}
	}

	farfree( tone );

	return 0;
}

int NEODRV_play( char *opt1, char *opt2 )
{
	if( opt1 != NULL )
	{
		/* se */
		r.h.ah = 0x01;
		r.h.dh = 0x00;
		r.h.dl = atoi( opt1 );
		int86x( 0x88, &r, &ro, &sr );

		printf( INFO[INFO_NO], r.h.dl );
	} else {
		/* music */
		r.h.ah = 0x00;
		int86x( 0x88, &r, &ro, &sr );
		r.h.ah = 0x02;
		int86x( 0x88, &r, &ro, &sr );
	}

	return 0;
}

int NEODRV_stop( void )
{
	r.h.ah = 0x03;
	int86x( 0x88, &r, &ro, &sr );

	return 0;
}

int NEODRV_fade( void )
{
	r.h.ah = 0x04;
	r.x.cx = 0x0090;
	r.x.dx = 0x00E1;
	int86x( 0x88, &r, &ro, &sr );

	return 0;
}
