#include <stdio.h>
#include <dos.h>
#include <memory.h>

#include "play6.h"
#include "..\common.h"
#include "..\extern.h"

int PLAY6_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x60, 0,  2, id );

	if( memcmp( id, "PLAY6", 5 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int PLAY6_load( char *filename )
{
	long				filesize;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	/* Music : DS:DX */
	r.h.al = 0x02;
	sr.ds  = FP_SEG( filename );
	r.x.dx = FP_OFF( filename );
	int86x( 0x60, &r, &ro, &sr );

	printf( INFO[INFO_LOAD], filename, filesize );

	return 0;
}

int PLAY6_play( char *opt1, char *opt2 )
{
	return 0;
}

int PLAY6_stop( void )
{
	r.h.al = 0x00;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int PLAY6_fade( void )
{
	r.h.ah = 0x06;
	r.h.al = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}
