#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "rme.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int RME_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0xF1, 1, 0x100, id );

	if( memcmp( id, "RME", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int RME_load( char *filename )
{
	long	filesize;

	filesize = GMPV4SP_load( filename, 0, 0, 1 );
	if( filesize == -1 ) return 1;

	GMPV4SP_address( &seg, &off, 0 );

	/* Music : DS:BX */
	r.x.ax = 0x0200;
	r.x.bx = off;
	r.x.cx = ( unsigned int )filesize;
	sr.ds = seg;
	int86x( 0xF1, &r, &ro, &sr );

	r.x.ax = 0x0D04;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}

int RME_play( char *opt1, char *opt2 )
{
	r.x.ax = 0x0400;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}

int RME_stop( void )
{
	r.x.ax = 0x0500;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}
