#include <stdio.h>
#include <string.h>

#include "common.h"
#include "extern.h"
#include "driver.h"
#include "gmpv4sp.h"
#include "gmpv4.h"

void usage( void )
{
	printf( "Usage: GMPV4 (driver) (filename) (...)\n" );
}

void list( void )
{
	int	i;

	for( i = 0; i != 256; i++ )
	{
		if( DRIVER[i].name == NULL )
		{
			printf( "\n" );
			return;
		}
		printf( "%s, ", DRIVER[i].name );
	}
}

int main( int ac, char **av )
{
	int		stop = 0;
	int		fade = 0;
	int		driver;

	printf( "GameMusicPlayerV4 190616 (c)KUROHANE Works\n" );
	printf( "\n" );

	if( strcmpi( av[1], OPT[OPT_LIST] ) == 0 )
	{
		list();
		return 0;
	}

	if( ac < 3 )
	{
		usage();
		return 0;
	}

	if( strcmpi( av[2], OPT[OPT_STOP] ) == 0 ) stop = 1;
	if( strcmpi( av[2], OPT[OPT_FADE] ) == 0 ) fade = 1;

	for( driver = 0; driver != 256; driver++ )
	{
		if( DRIVER[driver].name == NULL )
		{
			usage();
			return 0;
		}
		if( strcmpi( &av[1][1], DRIVER[driver].name ) == 0 ) break;
	}

	DRIVER_name = DRIVER[driver].name;

	/* exec driver */
	if(( *DRIVER[driver].func_check )() != 0 ) return -1;

	/* gmpv4sp */
	if( DRIVER[driver].gmpv4sp == 1 )
	{
		if( GMPV4SP_check() != 0 ) return -1;
	}

	if( stop == 1 )
	{
		( *DRIVER[driver].func_stop )();
		return 0;
	}
	if( fade == 1 )
	{
		( *DRIVER[driver].func_fade )();
		return 0;
	}

	( *DRIVER[driver].func_stop )();
	if(( *DRIVER[driver].func_load )( av[2] ) != 0 ) return -2;
	( *DRIVER[driver].func_play )( av[3], av[4] );

	printf( "\n" );

	return 0;
}
